Magellan Linux

Contents of /trunk/mkinitrd-magellan/busybox/scripts/trylink

Parent Directory Parent Directory | Revision Log Revision Log


Revision 984 - (show annotations) (download)
Sun May 30 11:32:42 2010 UTC (13 years, 11 months ago) by niro
File size: 9115 byte(s)
-updated to busybox-1.16.1 and enabled blkid/uuid support in default config
1 #!/bin/sh
2
3 debug=false
4
5 # Linker flags used:
6 #
7 # Informational:
8 # --warn-common
9 # -Map $EXE.map
10 # --verbose
11 #
12 # Optimizations:
13 # --sort-common reduces padding
14 # --sort-section alignment reduces padding
15 # --gc-sections throws out unused sections,
16 # does not work for shared libs
17 # -On Not used, maybe useful?
18 #
19 # List of files to link:
20 # $l_list == --start-group -llib1 -llib2 --end-group
21 # --start-group $O_FILES $A_FILES --end-group
22 #
23 # Shared library link:
24 # -shared self-explanatory
25 # -fPIC position-independent code
26 # --enable-new-dtags ?
27 # -z,combreloc ?
28 # -soname="libbusybox.so.$BB_VER"
29 # --undefined=lbb_main Seed name to start pulling from
30 # (otherwise we'll need --whole-archive)
31 # -static Not used, but may be useful! manpage:
32 # "... This option can be used with -shared.
33 # Doing so means that a shared library
34 # is being created but that all of the library's
35 # external references must be resolved by pulling
36 # in entries from static libraries."
37
38
39 try() {
40 printf "%s\n" "Output of:" >$EXE.out
41 printf "%s\n" "$*" >>$EXE.out
42 printf "%s\n" "==========" >>$EXE.out
43 $debug && echo "Trying: $*"
44 $@ >>$EXE.out 2>&1
45 return $?
46 }
47
48 check_cc() {
49 local tempname="/tmp/temp.$$.$RANDOM"
50 # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
51 # "-xc": C language. "/dev/null" is an empty source file.
52 if $CC $1 -shared -xc /dev/null -o "$tempname".o >/dev/null 2>&1; then
53 echo "$1";
54 else
55 echo "$2";
56 fi
57 rm "$tempname".o 2>/dev/null
58 }
59
60 check_libc_is_glibc() {
61 local tempname="/tmp/temp.$$.$RANDOM"
62 echo "\
63 #include <stdlib.h>
64 /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
65 #if defined(__GLIBC__) && !defined(__UCLIBC__)
66 syntax error here
67 #endif
68 " >"$tempname".c
69 if $CC "$tempname".c -c -o "$tempname".o >/dev/null 2>&1; then
70 echo "$2";
71 else
72 echo "$1";
73 fi
74 rm "$tempname".c "$tempname".o 2>/dev/null
75 }
76
77 EXE="$1"
78 CC="$2"
79 CFLAGS="$3"
80 LDFLAGS="$4"
81 O_FILES="$5"
82 A_FILES="$6"
83 LDLIBS="$7"
84
85 # The --sort-section option is not supported by older versions of ld
86 SORT_SECTION=`check_cc "-Wl,--sort-section,alignment" ""`
87
88 # Static linking against glibc produces buggy executables
89 # (glibc does not cope well with ld --gc-sections).
90 # See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
91 # Note that glibc is unsuitable for static linking anyway.
92 # We are removing -Wl,--gc-sections from link command line.
93 GC_SECTIONS=`(
94 . ./.config
95 if test x"$CONFIG_STATIC" = x"y"; then
96 check_libc_is_glibc "" "-Wl,--gc-sections"
97 else
98 echo "-Wl,--gc-sections"
99 fi
100 )`
101
102 # The --gc-sections option is not supported by older versions of ld
103 if test -n "$GC_SECTIONS"; then
104 GC_SECTIONS=`check_cc "$GC_SECTIONS" ""`
105 fi
106
107 # Sanitize lib list (dups, extra spaces etc)
108 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
109
110 # First link with all libs. If it fails, bail out
111 echo "Trying libraries: $LDLIBS"
112 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
113 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
114 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
115 try $CC $CFLAGS $LDFLAGS \
116 -o $EXE \
117 -Wl,--sort-common \
118 $SORT_SECTION \
119 $GC_SECTIONS \
120 -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
121 $l_list \
122 || {
123 echo "Failed: $l_list"
124 cat $EXE.out
125 exit 1
126 }
127
128 # Now try to remove each lib and build without it.
129 # Stop when no lib can be removed.
130 while test "$LDLIBS"; do
131 $debug && echo "Trying libraries: $LDLIBS"
132 all_needed=true
133 last_needed=false
134 for one in $LDLIBS; do
135 without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
136 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
137 l_list=`echo "$without_one" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
138 test x"$l_list" != x"" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
139 $debug && echo "Trying -l options: '$l_list'"
140 try $CC $CFLAGS $LDFLAGS \
141 -o $EXE \
142 -Wl,--sort-common \
143 $SORT_SECTION \
144 $GC_SECTIONS \
145 -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
146 $l_list
147 if test $? = 0; then
148 echo " Library $one is not needed, excluding it"
149 LDLIBS="$without_one"
150 all_needed=false
151 last_needed=false
152 else
153 echo " Library $one is needed, can't exclude it (yet)"
154 last_needed=true
155 fi
156 done
157 # All libs were needed, can't remove any
158 $all_needed && break
159 # Optimization: was the last tried lib needed?
160 if $last_needed; then
161 # Was it the only one lib left? Don't test again then.
162 { echo "$LDLIBS" | grep -q ' '; } || break
163 fi
164 done
165
166 # Make the binary with final, minimal list of libs
167 echo "Final link with: ${LDLIBS:-<none>}"
168 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
169 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
170 # --verbose gives us gobs of info to stdout (e.g. linker script used)
171 if ! test -f busybox_ldscript; then
172 try $CC $CFLAGS $LDFLAGS \
173 -o $EXE \
174 -Wl,--sort-common \
175 $SORT_SECTION \
176 $GC_SECTIONS \
177 -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
178 $l_list \
179 -Wl,--warn-common \
180 -Wl,-Map,$EXE.map \
181 -Wl,--verbose \
182 || {
183 cat $EXE.out
184 exit 1
185 }
186 else
187 echo "Custom linker script 'busybox_ldscript' found, using it"
188 # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
189 # .rodata : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
190 # *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
191 # *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
192 # This will eliminate most of the padding (~3kb).
193 # Hmm, "ld --sort-section alignment" should do it too.
194 try $CC $CFLAGS $LDFLAGS \
195 -o $EXE \
196 -Wl,--sort-common \
197 $SORT_SECTION \
198 $GC_SECTIONS \
199 -Wl,-T,busybox_ldscript \
200 -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
201 $l_list \
202 -Wl,--warn-common \
203 -Wl,-Map,$EXE.map \
204 -Wl,--verbose \
205 || {
206 cat $EXE.out
207 exit 1
208 }
209 fi
210
211 . ./.config
212
213 sharedlib_dir="0_lib"
214
215 if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
216 mkdir "$sharedlib_dir" 2>/dev/null
217 test -d "$sharedlib_dir" || {
218 echo "Cannot make directory $sharedlib_dir"
219 exit 1
220 }
221 ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
222
223 EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
224 try $CC $CFLAGS $LDFLAGS \
225 -o $EXE \
226 -shared -fPIC \
227 -Wl,--enable-new-dtags \
228 -Wl,-z,combreloc \
229 -Wl,-soname="libbusybox.so.$BB_VER" \
230 -Wl,--undefined=lbb_main \
231 -Wl,--sort-common \
232 $SORT_SECTION \
233 -Wl,--start-group $A_FILES -Wl,--end-group \
234 $l_list \
235 -Wl,--warn-common \
236 -Wl,-Map,$EXE.map \
237 -Wl,--verbose \
238 || {
239 echo "Linking $EXE failed"
240 cat $EXE.out
241 exit 1
242 }
243 $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
244 chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
245 echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
246 fi
247
248 if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
249 EXE="$sharedlib_dir/busybox_unstripped"
250 try $CC $CFLAGS $LDFLAGS \
251 -o $EXE \
252 -Wl,--sort-common \
253 $SORT_SECTION \
254 $GC_SECTIONS \
255 -Wl,--start-group $O_FILES -Wl,--end-group \
256 -L"$sharedlib_dir" -lbusybox \
257 -Wl,--warn-common \
258 -Wl,-Map,$EXE.map \
259 -Wl,--verbose \
260 || {
261 echo "Linking $EXE failed"
262 cat $EXE.out
263 exit 1
264 }
265 $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
266 echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
267 fi
268
269 if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
270 echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
271 gcc -DNAME_MAIN_CNAME -E -include include/autoconf.h include/applets.h \
272 | grep -v "^#" \
273 | grep -v "^$" \
274 > applet_lst.tmp
275 while read name main junk; do
276
277 echo "\
278 void lbb_prepare(const char *applet, char **argv);
279 int $main(int argc, char **argv);
280
281 int main(int argc, char **argv)
282 {
283 lbb_prepare(\"$name\", argv);
284 return $main(argc, argv);
285 }
286 " >"$sharedlib_dir/applet.c"
287
288 EXE="$sharedlib_dir/$name"
289 try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
290 -o $EXE \
291 -Wl,--sort-common \
292 $SORT_SECTION \
293 $GC_SECTIONS \
294 -L"$sharedlib_dir" -lbusybox \
295 -Wl,--warn-common \
296 || {
297 echo "Linking $EXE failed"
298 cat $EXE.out
299 exit 1
300 }
301 rm -- "$sharedlib_dir/applet.c" $EXE.out
302 $STRIP -s --remove-section=.note --remove-section=.comment $EXE
303
304 done <applet_lst.tmp
305 fi
306
307 # libbusybox.so is needed only for -lbusybox at link time,
308 # it is not needed at runtime. Deleting to reduce confusion.
309 rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
310 exit 0 # or else we may confuse make

Properties

Name Value
svn:executable *